'use strict';

angular.module('cityDue.busStop.gMaps-directive', [])
.controller('MapsController', function(){

})

.directive('gMaps', ['$rootScope','$log', 'geoLocationService', function($rootScope, $log, geoLocationService) {
	var styles = [
	  {
	    stylers: [
	      { hue: "#00ffe6" },
	      { saturation: -20 }
	    ]
	  },{
	    featureType: "road",
	    elementType: "geometry",
	    stylers: [
	      { lightness: 100 },
	      { visibility: "simplified" }
	    ]
	  },{
	    featureType: "road",
	    elementType: "labels",
	    stylers: [
	      { visibility: "off" }
	    ]
	  },
	  {
	  	featureType: "poi",
		elementType: "labels",
		stylers: [
		{ visibility: "off" }
		]
	  }
	];
	var imageIcon = {
	  url: "img/icon/bus3_mini.png",
	  size: new google.maps.Size(25, 25),
	  origin: new google.maps.Point(0, 0),
	  anchor: new google.maps.Point(12.5, 12.5),
	  scaledSize: new google.maps.Size(25, 25)
	};
	var userIcon = {
	  url: "img/icon/bus3_mini.png",
	  size: new google.maps.Size(25, 25),
	  origin: new google.maps.Point(0, 0),
	  anchor: new google.maps.Point(12.5, 12.5),
	  scaledSize: new google.maps.Size(25, 25)
	};

	return {
		restrict: 'A',
   		link: function(scope, element, attrs) {
			var map;
			var markerList = [];


	   		var mapOptions = {
				center: {lat: 51.504874, lng: -0.128206},
				zoom: 10,
				styles:styles,
				streetViewControl: false
			};
			map = new google.maps.Map(element[0], mapOptions);

			google.maps.event.addListener(map, 'dragend', function(){
				scope.$apply(function(){
					console.log(map.getCenter().lat());
					console.log("root_map", $rootScope);
					$rootScope.latitude = map.getCenter().lat();
					$rootScope.longitude = map.getCenter().lng();
					$rootScope.$emit('mapa_moved');
				});
			});

			var cleanMarkers = function(){
				console.log(markerList);
				for(var i=0;i<markerList.length;i++){
					markerList[i].setMap(null);
				}
   				markerList = [];
			};

			var loadList = function(list, oldList){
				if (list === 0){
					return;
				}
   				var marker, myLatlng, item;

				cleanMarkers();

				var infowindow = new google.maps.InfoWindow({
					content: ""
				});

			    google.maps.event.addListener(map, 'click', function() {
			      	infoWindow.close();
			    });


   				for (var i=0;i<list.length;i++){
   					item = list[i];
   					(function(item){
	   					myLatlng = new google.maps.LatLng(parseFloat(item.lat), parseFloat(item.lon));
		   				marker = new google.maps.Marker({
						    position: myLatlng,
						    map: map,
						    icon: imageIcon,
						    title:item.name
						});

		   				var stopId = item.id;
		   				var stopName = item.name;
		   				var message = "<a class='map-title' href='#/busStop/"+stopId+"'>" + stopName + "</a>";


						google.maps.event.addListener(marker, 'click', function() {
							
							infowindow.setOptions({
					            content: message
					        });
							infowindow.open(map,this);
						});

						markerList.push(marker);
					})(item);
	   			}
	   		};
	   		var userMarker;
	   		var loadMapByLatitude = function(value, oldValue){
	   			if (value === 0){
	   				return;
	   			}
	   			if (userMarker){
	   				userMarker.setMap(null);
	   			}	
   				userMarker = new google.maps.Marker({
				    position: new google.maps.LatLng(scope.latitude, scope.longitude),
				    map: map,
				    title:"user position"
				});

	   			map.setZoom(16);
	   			map.panTo({lat:scope.latitude, lng:scope.longitude});

				loadList(scope.stopList);
	   		}

	   		if (scope.latitude != null){
				loadMapByLatitude(scope.latitude);
			}
			//Add watchers to update the map
			scope.$watch(attrs.latitude, loadMapByLatitude);
			scope.$watch(attrs.stopList, loadList);
		}
    };
}]);