'use strict';

var nearbyViewCtrl = function($rootScope, $scope, $document, geoLocationService, loadStops, addPredictionToData){
	$scope.title="Nearby";
	$scope.stopList = [];
	$scope.latitude = $rootScope.latitude;
	$scope.longitude = $rootScope.longitude;
	$scope.refreshing = true;
	// Load the data for the first and second stops
	var loadPrediction = function(list){
		$scope.stopList = list;
		for(var i=0;i<$scope.stopList.length && i<2;i++){
			var busstop = $scope.stopList[i];
			addPredictionToData(busstop,3);
		}

		$scope.refreshing = false;
	};
	// Update the Geo Position
	var refreshLocation = function(){
		$scope.refreshing = true;
		geoLocationService($scope, function (latitude,longitude) {
			$scope.latitude = latitude;
			$scope.longitude = longitude;
			loadStops($scope.latitude, $scope.longitude, loadPrediction);
		});
	};
	$scope.refreshLocation = refreshLocation;
	if ($scope.latitude == null){
		refreshLocation();
	}else{
		loadStops($scope.latitude, $scope.longitude, loadPrediction);
	}
	
	$rootScope.$on('mapa_moved', function(){
		// console.log('map_moved');
		loadStops($rootScope.latitude, $rootScope.longitude, loadPrediction);
	});


	// [{"id":"BP1448","name":"BEULAH FAMILY CHURCH","desc":"BEULAH FAMILY CHURCH","lat":51.4063433908,"lon":-0.0994747144501,"routes":"450","distance":"17.288701"},{"id":"BP1432","name":"BEULAH CRESCENT \/ BEULAH FAMILY CHURCH","desc":"BEULAH CRESCENT \/ BEULAH FAMILY CHURCH","lat":51.4062858697,"lon":-0.0987006637255,"routes":"450","distance":"66.288701"},{"id":"BP1499","name":"OSBORNE GARDENS","desc":"OSBORNE GARDENS","lat":51.4070889189,"lon":-0.0999758143741,"routes":"450","distance":"133.690707"},{"id":"BP1431","name":"SPRINGFIELD ROAD","desc":"SPRINGFIELD ROAD","lat":51.408061342,"lon":-0.100050536393,"routes":"450","distance":"249.690707"},{"id":"BP1450","name":"SPRINGFIELD ROAD","desc":"SPRINGFIELD ROAD","lat":51.4083157932,"lon":-0.0991053490537,"routes":"450","distance":"257.288701"},{"id":"BP1434","name":"BEULAH ROAD","desc":"BEULAH ROAD","lat":51.4040947297,"lon":-0.0999992742741,"routes":"450","distance":"263.711299"},{"id":"BP1449","name":"OSBORNE ROAD \/ NORTHWOOD ROAD","desc":"OSBORNE ROAD \/ NORTHWOOD ROAD","lat":51.4077679089,"lon":-0.100810402432,"routes":"450","distance":"267.690707"},{"id":"17690","name":"PARK LAWN","desc":"PARK LAWN","lat":51.4056527673,"lon":-0.103471741122,"routes":"250","distance":"342.711299"},{"id":"BP1433","name":"BEULAH ROAD","desc":"BEULAH ROAD","lat":51.4036892636,"lon":-0.100504918512,"routes":"450","distance":"343.711299"},{"id":"17689","name":"PARK LAWN","desc":"PARK LAWN","lat":51.405857683,"lon":-0.103908990147,"routes":"250","distance":"351.711299"},{"id":"17687","name":"SANDFIELD ROAD","desc":"SANDFIELD ROAD","lat":51.4045744267,"lon":-0.102409256588,"routes":"250","distance":"383.711299"},{"id":"17688","name":"SANDFIELD ROAD","desc":"SANDFIELD ROAD","lat":51.4039675744,"lon":-0.101586092238,"routes":"250","distance":"390.711299"},{"id":"17692","name":"COUNTY ROAD","desc":"COUNTY ROAD","lat":51.4070599648,"lon":-0.104851385305,"routes":"250","distance":"460.690707"},{"id":"17685","name":"PARCHMORE METHODIST CHURCH","desc":"PARCHMORE METHODIST CHURCH","lat":51.4020679365,"lon":-0.100342061758,"routes":"250, 450","distance":"507.711299"},{"id":"BP1425","name":"HOWBERRY ROAD","desc":"HOWBERRY ROAD","lat":51.4093082017,"lon":-0.0965334175091,"routes":"450","distance":"548.288701"},{"id":"17686","name":"PARCHMORE METHODIST CHURCH","desc":"PARCHMORE METHODIST CHURCH","lat":51.401343878,"lon":-0.100055772073,"routes":"250, 450","distance":"565.711299"},{"id":"BP1426","name":"HOWBERRY ROAD","desc":"HOWBERRY ROAD","lat":51.4095639118,"lon":-0.0962208287846,"routes":"450","distance":"598.288701"},{"id":"17691","name":"COUNTY ROAD","desc":"COUNTY ROAD","lat":51.4078366128,"lon":-0.105610113992,"routes":"250","distance":"600.690707"},{"id":"33164","name":"GREEN LANE POST OFFICE","desc":"GREEN LANE POST OFFICE","lat":51.4088441232,"lon":-0.106186779205,"routes":"250","distance":"754.690707"},{"id":"26861","name":"THORNTON HEATH CLOCK TOWER","desc":"THORNTON HEATH CLOCK TOWER","lat":51.3996348093,"lon":-0.0989189817565,"routes":"250, 450","distance":"788.309293"},{"id":"17684","name":"THORNTON HEATH CLOCK TOWER","desc":"THORNTON HEATH CLOCK TOWER","lat":51.3993050998,"lon":-0.0991051676317,"routes":"250, 450","distance":"813.309293"},{"id":"BP1430","name":"DALE PARK ROAD","desc":"DALE PARK ROAD","lat":51.4105766955,"lon":-0.0943525253836,"routes":"450","distance":"841.288701"},{"id":"BP1427","name":"DALE PARK ROAD","desc":"DALE PARK ROAD","lat":51.4107633112,"lon":-0.0942153472071,"routes":"450","distance":"871.288701"},{"id":"25740","name":"THORNTON HEATH STATION #","desc":"THORNTON HEATH STATION #","lat":51.3984422487,"lon":-0.0996872270558,"routes":"198, 250, 450, 50","distance":"872.309293"},{"id":"25739","name":"THORNTON HEATH STATION #","desc":"THORNTON HEATH STATION #","lat":51.3986414849,"lon":-0.0992189363695,"routes":"198, 250, 450, 50","distance":"881.309293"},{"id":"17883","name":"BRAEMAR AVENUE","desc":"BRAEMAR AVENUE","lat":51.4044502307,"lon":-0.109747100599,"routes":"50","distance":"920.711299"},{"id":"17693","name":"GREEN LANE POST OFFICE","desc":"GREEN LANE POST OFFICE","lat":51.4097671035,"lon":-0.107097689769,"routes":"250","distance":"921.690707"},{"id":"17880","name":"EDERLINE AVENUE","desc":"EDERLINE AVENUE","lat":51.4060007692,"lon":-0.112213747318,"routes":"50","distance":"928.711299"},{"id":"17882","name":"BRAEMAR AVENUE","desc":"BRAEMAR AVENUE","lat":51.4039556751,"lon":-0.109192385634,"routes":"50","distance":"934.711299"},{"id":"17885","name":"SANDFIELD ROAD","desc":"SANDFIELD ROAD","lat":51.4018176191,"lon":-0.105988228943,"routes":"50","distance":"937.711299"}];
};

angular.module('cityDue.nearby', ['ngRoute'])

.config(['$routeProvider', function($routeProvider) {
  $routeProvider.when('/nearby/', {
    templateUrl: 'nearbyView/nearbyView.html',
    controller: 'NearbyViewCtrl'
  });
}])


.controller('NearbyViewCtrl', ['$rootScope', '$scope', '$window', 'geoLocationService', 'loadStops', 'addPredictionToData', nearbyViewCtrl]);
